﻿//----------------------------------------------------------
//  this.TASHandler
//----------------------------------------------------------
this.TASHandler
= function(TASValue:Number):Void
{
	
	if(PlayInfo.TASEnable == 0)
	{
		//TASValue = MovConst.CWTAS_090;
		TASValue = PlayInfo.TASPrevValues;
	}
	
	//if((PlayInfo.TASPrevValues == TASValue)
	
	if((PlayInfo.TASRotate == TASValue)
	&& (PlayInfo.StoryOn == false))
		return ;
		
	if(MovConst.CWTAS_180 == TASValue)
		return;
		
	
	EventEnable(false, 0);

	PlayInfo.TASRotate 	= TASValue;
	
	
	// Initialize current layer
	ext_fscommand2("SetVidUIEnable", 1);
	VideoOff();
	
	// Make screen by current angle
	switch(TASValue)
	{
		
	case MovConst.CWTAS_000:			
	//case MovConst.CWTAS_180: 
	
		// Initialize Object
		if(PlayInfo.StoryOn)	
		{
			MCCon = MCConS;
			VideoInit(MovConst.LAYER_S, TASValue);
			MCConS.Scene();
			
		}
		else
		{
			MCCon = MCConP;
			VideoInit(MovConst.LAYER_P, TASValue);
		}
		break;
	
	case MovConst.CWTAS_270: 
	case MovConst.CWTAS_090: 
	
		// Initialize Object
		MCCon = MCConL;
		VideoInit(MovConst.LAYER_L, TASValue);
			
		if(TASValue == MovConst.CWTAS_090) 
			MCConL._rotation = 0;
		else
		if(TASValue == MovConst.CWTAS_270) 
			MCConL._rotation = 180;
			
		break;
	}		
	
	MCCon.Init();
	systemInfo(1);
	
	if(PlayInfo.StoryOn && MovieIsPortrait(TASValue))
	{
		
		ext_fscommand2("SetVidUIEnable", 1);
		
		MCTAS.onEnterFrame = function()
		{	
			if(MCConS.thumbnailLoadCnt == 12)
			{
				delete this.onEnterFrame;
				if(PlayInfo.PlayState == 0) 
					cmd.Proc(cmd.PAUSE);
				
				MCCon.DrawPlayTime(1);
				EventEnable(true, 0);
			
			}	
		}	
	}
	else
	{
		
		MCTAS.cnt = 0;
		MCTAS.onEnterFrame = function()
		{
			if(MCTAS.cnt > 0)
			{
				delete this.onEnterFrame;
				
				
				if(PlayInfo.PlayState == 0)
					cmd.Proc(cmd.PAUSE);
				VideoOn();	
				
				if(MovieIsLandScape(TASValue))
				{
					if(MCConL.ModeUI == 0)
						ext_fscommand2("SetVidUIEnable", 0);
					else
						ext_fscommand2("SetVidUIEnable", 1);
				}	
				else
				{
					ext_fscommand2("SetVidUIEnable", 1);
				}
				EventEnable(true, 0);
			
			}	
			MCTAS.cnt++;
		}	
	}
	
	DrawUI(1);
	PlayInfo.TASPrevValues = TASValue;	
	trace("_root.TAS_Handler-");
}	
//----------------------------------------------------------
// this.DrawUI
//----------------------------------------------------------
this.DrawUI
= function(force:Number):Void
{
	
	PlayInfo.EffectIdx = ext_fscommand2("GetJetEffectIndex");
	MCCon.DrawUI(force);
	
}
//----------------------------------------------------------
// this.KeyHandler
//----------------------------------------------------------
this.KeyHandler
= function(keyType:Number):Void
{
	
	MCConL.TopUICount = 0;
	// main checker
	switch(keyType)
	{
		case MovConst.KEY_DISPLAY_ROTATE:
			var tas = ext_fscommand2("GetEtcTASValue");
			if(PlayInfo.TASOn == true)
			{
				if(PlayInfo.TASEnable == 1)
				{
					if(PlayInfo.StoryOn && MovieIsLandScape(tas))
					{
						var prev = MCConS.prevIdx;
						var prevThumb = MCConS["mc_thumbnail_"+prev];
						prevThumb.bcnt = 0;
						prevThumb.MCScreen._visible 			= false;
						prevThumb.MCScreen.txt_time._visible 	= false;
						prevThumb.txt_time._visible 			= true;		
						prevThumb.mc_loading2._visible 			= true;
						
						MCTAS.onEnterFrameCnt = 0;
						MCTAS.onEnterFrame = function()
						{
							if(this.onEnterFrameCnt > 0)
							{
								delete this.onEnterFrame;
								TASHandler(tas);
							}
							this.onEnterFrameCnt++;
						}
					}
					else
					{
						TASHandler(tas);
					}		
				}
			}
			break;
			
		case MovConst.KEY_PLAY_LONG:
			cmd.Proc(cmd.ALPHA ,{alpha:10, enable:0});
			cmd.Proc(cmd.COLORKEY ,{colorkey:0x010203, enable:0});
			cmd.Proc(cmd.PAUSE);
			PlayInfo.PlayState = 0;
			ext_fscommand2("SetVidUIEnable", 1);
			ext_fscommand2("SetVidCaptionEnable", 0);
			_global.Load_SWF(MODE_MAIN);
			break;
			
			
		case MovConst.KEY_PLAY_SHORT:
			if(CheckMediaError(0))
				return;
		
			if(PlayInfo.PlayState)
			{
				cmd.Proc(cmd.PAUSE);
				PlayInfo.PlayState = 0;
			}
			else
			{
				cmd.Proc(cmd.PLAY);
				PlayInfo.PlayState = 1;
			}
			DrawUI(1);

			break;
			
		case MovConst.KEY_PLUS_SHORT:
			{
				if(MCConL.ModeUI == 0)
					MCScreen0.onPress();
			}
			cmd.Proc(cmd.VOLUP);
			DispVolume(1);
			break;
			
		case MovConst.KEY_PLUS_LONG:
			{
				if(MCConL.ModeUI == 0)
					MCScreen0.onPress();
			}
			cmd.Proc(cmd.VOLUP);
			DispVolume(1);
			break;
			
		case MovConst.KEY_MINUS_SHORT:
			{
				if(MCConL.ModeUI == 0)
					MCScreen0.onPress();
			}
			cmd.Proc(cmd.VOLDN);
			DispVolume(1);
			break;
			
		case MovConst.KEY_MINUS_LONG:
			{
				if(MCConL.ModeUI == 0)
					MCScreen0.onPress();
			}
			cmd.Proc(cmd.VOLDN);
			DispVolume(1);
			break;		
			
		case MovConst.KEY_REW_SHORT:
		case MovConst.TOUCH_REW_SHORT:
			
			if(CheckMediaError(0))
				return;
					
			{
				var skipLength = ext_fscommand2("GetVidSkipLength")+1;
				for(i = 0; i < skipLength; i++)
					cmd.Proc(cmd.REW);
				cmd.Proc(cmd.REW_FF_END);
			}
			
			break;
			
		case MovConst.KEY_REW_LONG:
		case MovConst.TOUCH_REW_LONG:		
		
			if(CheckMediaError(0))
				return;
			
			cmd.Proc(cmd.REW);
			break;
			
		case MovConst.KEY_FF_SHORT:
		case MovConst.TOUCH_FF_SHORT:
		
			if(PlayInfo.openState == MovConst.OPEN_FAIL)
					return;
		
			if(PlayInfo.openState == 0)
			{
				var skipLength = ext_fscommand2("GetVidSkipLength")+1;
				for(i = 0; i < skipLength; i++)
					cmd.Proc(cmd.FF);
				cmd.Proc(cmd.REW_FF_END);
			}
			
			break;
			
		case MovConst.KEY_FF_LONG:
		case MovConst.TOUCH_FF_LONG:
		
			if(PlayInfo.openState == MovConst.OPEN_FAIL)
					return;
					
			if(PlayInfo.openState == 0)
			{
				cmd.Proc(cmd.FF);
			}
			break;
			
		case MovConst.KEY_RELEASE_LONG:
		
			if(PlayInfo.openState == MovConst.OPEN_FAIL)
					return;
					
			if(PlayInfo.openState == 0)
			{
				cmd.Proc(cmd.REW_FF_END);
			}
			break;
			
		case MovConst.KEY_DISPLAY_UPDATE:
		
			systemInfo(1);		
			
			MCConP.ClosePopup();
			MCConL.ClosePopup();
			
			//----------------------------------------------
			// Get information
			//----------------------------------------------
			// Setting title name
			cmd.Proc(cmd.CURRIDX ,cmd.pkt);
			cmd.Proc(cmd.INFO ,cmd.pkt={idx:cmd.pkt.curIdx});
			cmd.Proc(cmd.AB, {mod:0, enb:0});
			
			// set play info
			PlayInfo.ABMode 		= MovConst.CWAB_OFF;
			PlayInfo.TitleName		= cmd.pkt.title;
			PlayInfo.ABLength 		= 0;
			PlayInfo.ABStartSec		= 0;
			PlayInfo.ABEndSec		= 0;
			PlayInfo.Width			= ext_fscommand2("GetVidWidth");
			PlayInfo.Height			= ext_fscommand2("GetVidHeight");
			PlayInfo.VidFrameRate	= ext_fscommand2("GetVidFrameRate");
			PlayInfo.AudSampleRate	= ext_fscommand2("GetVidSampleRate");
			PlayInfo.AudBitrate		= ext_fscommand2("GetVidBitRate");
			//----------------------------------------------
			// Check Flash update command
			//----------------------------------------------
			var OpenState = ext_fscommand2("GetVidOpenState");
			switch(OpenState)
			{
			case 0: // SUCCESS
			{
				if(PlayInfo.Width == 480 && PlayInfo.Height == 272)
					PlayInfo.ScaleOn = false;
				else
					PlayInfo.ScaleOn = true;
			}
			break;
			case 1:	// FAIL
			{
				PlayInfo.Width			= -1;
				PlayInfo.Height			= -1;
				PlayInfo.VidFrameRate	= -1;
				PlayInfo.AudSampleRate	= -1;
				PlayInfo.AudBitrate		= -1;
				MCConL.TopUICount	= MovConst.TIME_COUNT*5;
			}
			break;
			case 2:	// STOP
			{
				cmd.Proc(cmd.CURRIDX ,cmd.pkt);
				cmd.Proc(cmd.OPEN ,{idx:cmd.pkt.curIdx ,mode:0});
				cmd.Proc(cmd.PAUSE);
			}
			break;	
			case 3:
			break;
			case 4: // restore
			{
				PlayInfo.PlayState = ext_fscommand2("GetVidState");
				PlayInfo.TASRotate = -1;
				
				
				MCScreen0.onPress();
				TASHandler(ext_fscommand2("GetEtcTASValue"));					
				MCCon.DrawPlayTime(1);
				return;
			}
			break;
			}
			
			
				
			//----------------------------------------------
			// Draw new information
			//----------------------------------------------
			MCConL.MCSeekBar.MCSeekMeterAB._height = 0;	
			cmd.Proc(cmd.CURRIDX ,cmd.pkt);
			if(PlayInfo.curIdx	!= cmd.pkt.curIdx)
			{
				
				if(PlayInfo.StoryOn == true)
				{
					PlayInfo.TASRotate 		= -1;
					PlayInfo.StoryOn 		= false;
					PlayInfo.StoryCacheOn 	= false;
					if(PlayInfo.IsFirst == 0)
					{
						if(ext_fscommand2("GetSysHoldKey") != 1)
						{
							TASHandler(ext_fscommand2("GetEtcTASValue"));
						}
					}
				}
				else
				{
					PlayInfo.StoryCacheOn = false;
				}
					
				PlayInfo.curIdx = cmd.pkt.curIdx;
			}
			
			
			if(PlayInfo.IsFirst)
			{
				PlayInfo.IsFirst = 0;
			}
			else
			{
				if(ext_fscommand2("GetSysHoldKey") != 1)
				{
					if(PlayInfo.TASEnable == 1)
					{
						TASHandler(ext_fscommand2("GetEtcTASValue"));
					}
				}

			}
			
			PlayInfo.PlayState = ext_fscommand2("GetVidState");
			DrawUI(1);
			MCCon.DrawPlayTime(1);
			break;
		
		case MovConst.VKEY_PLUS:
			if(MovieIsLandScape(PlayInfo.TASRotate))
			{
				var idx;
				var quickList 	= MCConL.MCQuickList;
				
				if(PlayInfo.TASRotate == MovConst.CWTAS_090)
					idx = quickList.seeki-5;
				else
					idx = quickList.seeki+5;
				
				quickList.seeki = idx;
				quickList.DrawList(idx);
				quickList.DrawMovSelect(2);
			}
			else
			if(MovieIsPortrait(PlayInfo.TASRotate))
			{
				if(MCConP.MCPopJetEffect._visible == true)
				{
					MCConP.MCPopJetEffect.fn_NextAction_EQPopup(MCConP.MCPopJetEffect, 5, false);
				}
			}
			
			break;
			
		case MovConst.VKEY_MINUS:
			if(MovieIsLandScape(PlayInfo.TASRotate))
			{
				var idx;
				var quickList 	= MCConL.MCQuickList;
				
				if(PlayInfo.TASRotate == MovConst.CWTAS_090)
					idx = quickList.seeki+5;
				else
					idx = quickList.seeki-5;
				
				quickList.seeki = idx;
				quickList.DrawList(idx);
				quickList.DrawMovSelect(2);
			}
			else
			if(MovieIsPortrait(PlayInfo.TASRotate))
			{
				if(MCConP.MCPopJetEffect._visible == true)
				{
					MCConP.MCPopJetEffect.fn_PrevAction_EQPopup(MCConP.MCPopJetEffect, 5, false);
				}
			}
			
			break;
			
		case MovConst.VKEY_FF:
			break;
			
		case MovConst.VKEY_REW:
			break;
			
		case MovConst.KEY_PLAY_SHORT:
			break;
			
		case MovConst.KEY_HOLD:
			DispHold(1);
			
			if(ext_fscommand2("GetSysHoldKey") == 0)
			{
				EventEnable(true, 0);
				TASHandler(ext_fscommand2("GetEtcTASValue"));
			}
			break;
	}
	
	trace("this.KeyHandler-");
	
}
//----------------------------------------------------------
// MCScreen0
//----------------------------------------------------------
MCScreen0.onPress = function()
{
	if(PlayInfo.InputOn)
	{
		trace("MCScreen0.onPress");
		if(MovieIsLandScape(PlayInfo.TASRotate))
		{
			if(MCConL._visible == true) 
			{
				ext_fscommand2("SetVidUIEnable", 0);
				_root.MCConL.ModeUI = 0;
				MCConL._visible = false;
			}
			else
			{
			
				ext_fscommand2("SetVidUIEnable", 1);
				_root.MCConL.ModeUI = 1;
				MCConL._visible = true;
				
				MCConL.TopUICount	= MovConst.TIME_COUNT;
			}
		}
	}
}
//----------------------------------------------------------
//	InitMovie
//----------------------------------------------------------
this.InitMovie 
= function(Void):Void
{
	//2008-11-22 1:27 firmware initialize
	ext_fscommand2("SetEtcLCDTimerOff", 1);			
	ext_fscommand2("EtcModChangeMode", "Video");
	ext_fscommand2("KeyVidInit");
	
	
	// Initialize Movie clip object
	MCCon = new Object();
	MCConP._visible = false;
	MCConL._visible = false;
	MCConS._visible = false;
	MCConL.MCFooter.MCSideA._visible = true;
	MCConL.MCFooter.MCSideB._visible = false;
	MCConL.MCFooter.MCSideB.MCOut._alpha = 30;

	
	EventEnable(false, 0);

	MCConL.MCQuickList.Init();
	
	// Create P type loader
	this.mclLoader 	= new MovieClipLoader();
	this.mclLoader.addListener(MCConS.mclListener);
	
	// Create S type loader
	this.mclLoader0 = new MovieClipLoader();
	this.mclLoader0.addListener(MCConL.mclListener);
	
	// Create command object
	this.CreateCommand(_root);
	

	// Install key/touch handler
	this.Key_CreateKeyListner(KeyHandler);
	this.Key_CreateTouchListener(KeyHandler);
	
	PlayInfo.IsFirst = 1;
	
	// Get Config
	ext_fscommand2("GetEtcUIConfig", 1, "PlayInfo.configString");
	var configArray:Array = PlayInfo.configString.split("|");
	if(configArray[0] != "VER21")
	{
		trace("rewrite version information");
		MovieInfoStore();
	}
	else
	{
		PlayInfo.HWScaler 		= Number(configArray[1]);
		PlayInfo.PrevPlayState 	= Number(configArray[2]);
		PlayInfo.TASEnable	 	= Number(configArray[3]);
		PlayInfo.TASPrevValues	= Number(configArray[4]);
		
		if(PlayInfo.TASEnable == 0)
		{
			if((PlayInfo.TASPrevValues == MovConst.CWTAS_000)
			|| (PlayInfo.TASPrevValues == MovConst.CWTAS_180))
			{
				PlayInfo.TASPrevValues = MovConst.CWTAS_270;
				MovieInfoStore();
			}
		}
		
	}
	
	trace("PlayInfo.TASEnable: " + PlayInfo.TASEnable);
	if(PlayInfo.TASEnable == 1)
	{
		MCConL.MCFooter.MCSideB.MCPivotOn._visible = true;
		MCConL.MCFooter.MCSideB.MCPivotOff._visible = false;
	}
	else
	if(PlayInfo.TASEnable == 0)
	{
		MCConL.MCFooter.MCSideB.MCPivotOn._visible = false;
		MCConL.MCFooter.MCSideB.MCPivotOff._visible = true;
		
	}
	
	MCConL.MCFooter.MCSideB.MCPivotOn._visible = false;
	MCConL.MCFooter.MCSideB.MCPivotOff._visible = true;
	
	trace("tas enable: " + PlayInfo.TASEnable);
	
	cmd.Proc(cmd.AB, {mod:0, enb:0});
	cmd.Proc(cmd.REPEAT ,cmd.pkt={set:0});
	PlayInfo.RptMode = cmd.pkt.rpt;
	cmd.Proc(cmd.BOUNDARY ,cmd.pkt={set:0});
	PlayInfo.BndMode = cmd.pkt.bnd; 
	
		
	// Setting title name
	cmd.Proc(cmd.CURRIDX ,cmd.pkt);
	cmd.Proc(cmd.INFO ,cmd.pkt={idx:cmd.pkt.curIdx});
	cmd.Proc(cmd.AB, {mod:0, enb:0});
	
	PlayInfo.TitleName			= cmd.pkt.title;
	MCConL.MCHeader.tTitle.text = cmd.pkt.title;
	MCConP.MCHeader.tTitle.text = cmd.pkt.title;
	MCConS.MCHeader.tTitle.text = cmd.pkt.title;
	
	if(PlayInfo.openState == MovConst.OPEN_FAIL)
	{
		trace("check!!!\n");
		MCConP.MCHeader.MCGoList.gotoAndPlay(3);
		MCConL.MCHeader.MCGoList.gotoAndPlay(3);
	}

	{
		VideoOff();
		
		if(PlayInfo.TASEnable == 1)
		{
			PlayInfo.TASRotate = ext_fscommand2("GetEtcTASValue");	
		}
		else
		{
			PlayInfo.TASRotate = PlayInfo.TASPrevValues;
		}
		
		if(MovieIsPortrait(PlayInfo.TASRotate))	// Portrait mode
		{
			ext_fscommand2("SetVidUIEnable", 1);
			
			MCCon = MCConP;
			MCCon.Init();
			DrawUI(1);
			systemInfo(1);			
			
			VideoInit(MovConst.LAYER_P, PlayInfo.TASRotate);
			MCTick6.cnt = 0;
			MCTick6.onEnterFrame = function()
			{
				if(MCTick6.cnt > 0) 
				{
					delete MCTick6.onEnterFrame;
	
					StartModeOpen(_global.g_PrevLauncherMode, PlayInfo.PrevPlayState);
					VideoOn();
					EventEnable(true, 0);
					
				}
				MCTick6.cnt++
				
			}
		}
		else
		{
			ext_fscommand2("SetVidUIEnable", 1);
			
			MCCon = MCConL;
			MCCon.Init();
			DrawUI(1);
			systemInfo(1);	
			
			VideoInit(MovConst.LAYER_L, PlayInfo.TASRotate);
			VideoOn();			
			if(PlayInfo.TASRotate == MovConst.CWTAS_090) 
				MCConL._rotation = 0;
			else
			if(PlayInfo.TASRotate == MovConst.CWTAS_270) 
				MCConL._rotation = 180;
				
			StartModeOpen(_global.g_PrevLauncherMode, PlayInfo.PrevPlayState);
			EventEnable(true, 0);
		}
	
	}
	
}
//----------------------------------------------------------
// this.DeinitMovie 
//----------------------------------------------------------
this.DeinitMovie 
= function(Void):Void
{
	delete this.onEnterFrame;
	delete MCCon;
	delete _root.mclLoader;
	delete _root.mclLoader0;
	delete MCConS.mclListener;
	delete MCConL.mclListener;
	
	delete PlayInfo.configString;
	delete PlayInfo;
	delete MovConst;
	delete EQString;
	
	
	_root.DestroyCommand(_root);
	
	ext_fscommand2("SetEtcLCDTimerOff", 0);
	ext_fscommand2("KeyVidDeinit");
	
	this.Key_RemoveKeyListener();
	this.Key_RemoveTouchListener();
	delete KeyObject;	
	delete MouseObject;
}
//----------------------------------------------------------
// this.onUnload 
//----------------------------------------------------------
this.onUnload 
= function(Void):Void
{
	this.DeinitMovie();
}

////////////////////////////////////////////////////////////
//
//  Entry point
//
////////////////////////////////////////////////////////////
this.InitMovie();

			
_root.onMouseUp = function()
{
	MCConL.TopUICount	= MovConst.TIME_COUNT;
	
	if(PlayInfo.SeekPressed == true)
	{
		MCConL.pressed = false;
		MCConP.MCSeekBar.MCSeekMeter._alpha = 100;
		MCConL.MCSeekBar.MCSeekMeter._alpha = 100;
		ext_fscommand2("KeyVidLongKeyRelease");
		PlayInfo.SeekPressed = false;
	}
}
_root.onMouseDown = function()
{
	MCConL.TopUICount	= MovConst.TIME_COUNT;
}

_root.onMouseMove = function()
{
	MCConL.TopUICount	= MovConst.TIME_COUNT;
	
	if(MCConL.pressed == true)
	{
		if((PlayInfo.TASRotate == MovConst.CWTAS_090)
		|| (PlayInfo.TASRotate == MovConst.CWTAS_270))
		{
			var seekerBar	= MCConL.MCSeekBar;
			var cur 		= seekerBar._ymouse;
			var tot			= seekerBar._height;
			var ratio		= int((cur*100)/tot);
			var tmTot		= ext_fscommand2("GetVidTotalTime")*1000;
			var tmTrg		= int((tmTot*ratio)/100);
			
			
			MCConL.MCSeekBar.MCSeekMeter._height = (430*ratio)/100;
			MCConL.MCSeekBar.MCSeeker._y = (430*ratio)/100;
				
			ext_fscommand2("KeyVidDirectSeek", tmTrg);
			
			
		}
		if((PlayInfo.TASRotate == MovConst.CWTAS_000)
		|| (PlayInfo.TASRotate == MovConst.CWTAS_180))
		{
			var seekerBar	= MCConP.MCSeekBar;
			var cur 		= seekerBar._xmouse;
			var tot			= seekerBar._width;
			var ratio		= int((cur*100)/tot);
			var tmTot		= ext_fscommand2("GetVidTotalTime")*1000;
			var tmTrg		= int((tmTot*ratio)/100);
			
			
			MCConP.MCSeekBar.MCSeekMeter._width = (272*ratio)/100;
			MCConP.MCSeekBar.MCSeeker._x = (272*ratio)/100;
				
			ext_fscommand2("KeyVidDirectSeek", tmTrg);
			
		}
		
		MCCon.DrawPlayTime(1);
		
	}
		
}	
