
var gVideoWidth	:Number;	// for system communication
var gVideoHeight	:Number;	// for system communication
var gTmpString		:String;	// for system communication
//---------------------------------------------------------
// CreateCommand
//---------------------------------------------------------
_root.CreateCommand
= function(trg:Object):Object
{
	// need exception process
	trace(this + "+");
	
	// create object
	trg.cmd = new Object();
	
	// initialize variable
	trg.cmd.FF				= 10000;
	trg.cmd.REW				= 10001;
	trg.cmd.REW_FF_END		= 10002;
	trg.cmd.CURRIDX			= 10003;
	trg.cmd.PREVIDX			= 10004;
	trg.cmd.NEXTIDX			= 10005;
	trg.cmd.TOTALIDX		= 10006;
	trg.cmd.INFO			= 10007;
	trg.cmd.OPEN			= 10008;
	trg.cmd.PLAY			= 10009;
	trg.cmd.PAUSE			= 10010;
	trg.cmd.STOP			= 10011;
	trg.cmd.VOLUP			= 10012;
	trg.cmd.VOLDN			= 10013;
	trg.cmd.ALPHA			= 10014;
	trg.cmd.COLORKEY		= 10015;
	trg.cmd.HOLDKEY			= 10016;
	trg.cmd.BATTERY			= 10017;
	trg.cmd.BMK				= 10018;
	trg.cmd.DPL				= 10019;
	trg.cmd.CAPTURE			= 10020;
	trg.cmd.EQ_POPUP		= 10021;
	trg.cmd.SCRMETRIC		= 10022;
	trg.cmd.COLORKEY		= 10023;
	trg.cmd.ALPHA			= 10024;
	trg.cmd.SCRENABLE		= 10025;
	trg.cmd.PTIME			= 10026;
	trg.cmd.SCR				= 10027;
	trg.cmd.REPEAT			= 10028;
	trg.cmd.BOUNDARY		= 10029;
	trg.cmd.AB				= 10030;
	
	// make temporal variable
	/*
	trg.cmd.tmpNumber0	= -1;
	trg.cmd.tmpNumber1	= -1;
	trg.cmd.tmpNumber2	= -1;
	trg.cmd.tmpNumber3	= -1;
	trg.cmd.tmpString0	= "Tmp0";
	trg.cmd.tmpString1	= "Tmp1";
	*/
	trg.cmd.pkt			= new Object();
	
	// make function
	trg.cmd.Proc		
	= function(code:Number, com:Object):Number
	{
		
		var result = 0;
		
		//trace(this + " code: " + code + " com: " + com);
		
		switch(code)
		{
			//--------------------------------------------------
			//	FF
			//--------------------------------------------------
			case this.FF:
			// description >				
			// 	Fast forward
			//
			// com : none
			{
				ext_fscommand2("KeyVidLongFF");
			}
			break;
			//--------------------------------------------------
			//	S2_MOVIE_EVT_REW
			//--------------------------------------------------
			case this.REW:
			// description >
			// 	Fast rewind
			//
			// com : none
			{
				ext_fscommand2("KeyVidLongREW");
			}
			break;
			//--------------------------------------------------
			//	S2_MOVIE_EVT_REW_FF_END
			//--------------------------------------------------
			case this.REW_FF_END:
			// description >
			// 	Post process for fast forward or fast rewind
			//
			// com : none
			{
				ext_fscommand2("KeyVidLongKeyRelease");
			}
			break;
			//--------------------------------------------------
			//	S2_MOVIE_EVT_CURRIDX
			//--------------------------------------------------
			case this.CURRIDX:
			// description >
			// 	Get current boundary's current index (zero based index)
			//
			// com 
			// - (i):None
			// - (o):idx - current file index in selected boundary
			{
				var idx = ext_fscommand2("GetEtcCurPLIndex"); 
				trace("######### current index of command module: " + idx);
				com.curIdx = idx;
				if(com.curIdx < 0) 
				{
					PlayInfo.openState = MovConst.OPEN_FAIL;
					result = -1;
					trace("MovConst.OPEN_FAIL!!!\n");
				}
				else
				{
					PlayInfo.openState = MovConst.OPEN_SUCCESS;
					trace("MovConst.OPEN_SUCCESS!!!\n");
				}
			}
			break;
			//--------------------------------------------------
			//	S2_MOVIE_EVT_PREVIDX
			//--------------------------------------------------
			case this.PREVIDX:
			// description >
			// 	Get current boundary's previous index (zero based index)
			//
			// - (i):None
			// - (o):idx - previous file index in selected boundary
			{
				var idx, total;
	
				idx 	= ext_fscommand2("GetEtcCurPLIndex");
				total	= ext_fscommand2("GetEtcTotalPLNum");
				idx--;
				if(idx < 0) idx = total-1;
				
				if(idx < 0) 
				{
					PlayInfo.openState = MovConst.OPEN_FAIL;
				}
				else
				{
					PlayInfo.openState = MovConst.OPEN_SUCCESS;
				}
				com.idx = idx;
			}
			break;
			//--------------------------------------------------
			//	S2_MOVIE_EVT_NEXTIDX
			//--------------------------------------------------
			case this.NEXTIDX:
			// description >
			// 	Get current boundary's next index (zero based index)
			//
			// - (i):None
			// - (o):idx - next file index in selected boundary
			{
				var idx, total;
	
				idx 	= ext_fscommand2("GetEtcCurPLIndex");
				total	= ext_fscommand2("GetEtcTotalPLNum");
				idx++;
				if(idx > (total-1)) idx = 0;
	
				com.idx = idx;
			}
			break;
			//--------------------------------------------------
			//	S2_MOVIE_EVT_TOTALIDX
			//--------------------------------------------------
			case this.TOTALIDX:
			// description >
			// 	Get current boundary's total number
			//
			// - (i):None
			// - (o):idx - total file index in selected boundary		
			{
				var idx = ext_fscommand2("GetEtcTotalPLNum");
				com.idx = idx;
	
			}
			break;
			//--------------------------------------------------
			//	S2_MOVIE_EVT_INFO
			//--------------------------------------------------		
			case this.INFO:
			// description >
			// 	Get selected file information
			//		
			// - (i):idx 	- wanted file's index in selected boundary
			// - (o):title 	- selected file's filename
			{
				ext_fscommand2("GetEtcFileName", com.idx, "gTmpString");			
					
				com.title 	= gTmpString;
			}
			break;
			//--------------------------------------------------
			//	S2_MOVIE_EVT_OPEN
			//--------------------------------------------------
			case this.OPEN:
			// description >
			// 	Open video file and to ready play state (only Open, not played)
			//
			// - (i):mode   - open mode
			// - (i):idx 	- wanted file's index in selected boundary
			{
				
				trace("open mode: " +  com.mode);
				trace("open index: " +  com.idx);
			
				ext_fscommand2("SetVidStartMode", com.mode);
				com.state = ext_fscommand2("KeyVidOpen", com.idx);
				trace("is opened!!!!!!!!!!!!: " + com.state);
			}
			break;
			//--------------------------------------------------
			//	S2_MOVIE_EVT_PLAY
			//--------------------------------------------------
			case this.PLAY:
			// description >
			// 	Play current video contents
			//
			// com : none
			{
				ext_fscommand2("KeyVidPlay");
			}
			break;
			//--------------------------------------------------
			//	S2_MOVIE_EVT_PAUSE
			//--------------------------------------------------
			case this.PAUSE:
			// description >
			// 	Pause current video contents
			//
			// com : none
			{
				ext_fscommand2("KeyVidPause");
			}
			break;
			//--------------------------------------------------
			//	S2_MOVIE_EVT_STOP
			//--------------------------------------------------
			case this.STOP:
			// description >
			// 	Stop current video contents
			//
			// com : none
			{
				ext_fscommand2("KeyVidStop");
			}
			break;
			//--------------------------------------------------
			//	S2_MOVIE_EVT_VOLUP
			//--------------------------------------------------		
			case this.VOLUP:
			// description >
			// 	Volume up to next step 
			//
			// com : none
			{
				ext_fscommand2("KeyComPlus");
			}
			break;
			//--------------------------------------------------
			//	S2_MOVIE_EVT_VOLDN
			//--------------------------------------------------		
			case this.VOLDN:
			// description >
			// 	Volume down to prev step
			//
			// com : none
			{
				ext_fscommand2("KeyComMinus");
			}
			break;		
			//--------------------------------------------------
			//	S2_MOVIE_EVT_BMK
			//--------------------------------------------------
			case this.BMK:
			// description >
			// 	Add Bookmark 
			//
			// com : none
			{
				ext_fscommand2("KeyVidBookmark");
			}
			break;
			case this.DPL:
			// description >
			// 	Add Dynamic play list 
			//
			// com : none
			{
				ext_fscommand2("KeyVidFavorite");
			}
			break;
			//--------------------------------------------------
			//	S2_MOVIE_EVT_CAPTURE
			//--------------------------------------------------
			case this.CAPTURE:
			// description >
			// 	Capture current video screen
			//
			// com : none
			{
				ext_fscommand2("KeyVidCapture");
			}
			break;
			//--------------------------------------------------
			//	S2_MOVIE_EVT_SCRALPHA
			//--------------------------------------------------
			case this.ALPHA:
			// - (i):alpha 	- layer's alpha value
			// - (i):enable	- layer's alpha enable
			{
				ext_fscommand2("SetVidAlpha", com.alpha, com.enable);
			}
			break;
			//--------------------------------------------------
			//	S2_MOVIE_EVT_SCRCOLORKEY
			//--------------------------------------------------
			case this.COLORKEY:
			// - (i):colorkey	- layer's colorkey value
			// - (i):enable		- layer's colorkey enable
			{
				ext_fscommand2("SetVidColorKey", com.colorkey, com.enable);
			}
			break;
			//--------------------------------------------------
			//	SCREEN
			//--------------------------------------------------
			case this.SCR:
			{
				if(com.s < 0) com.s = 0;
				ext_fscommand2("SetVidSCR", 
						com.x, com.y, com.w, com.h, com.r, 
						com.s, com.d);	
			}
			break;
			//--------------------------------------------------
			//	REPEAT
			//--------------------------------------------------
			case this.REPEAT:
			{
				if(com.set == 0)
					com.rpt = ext_fscommand2("GetVidRepeat");
				else
				if(com.set == 1)
					ext_fscommand2("SetVidRepeat", com.rpt);
				
			}			
			break;
			case this.BOUNDARY:
			{
				if(com.set == 0)
					com.bnd = ext_fscommand2("GetVidBoundary");
				else
				if(com.set == 1)
					ext_fscommand2("SetVidBoundary", com.bnd);
				
			}			
			break;
			case this.AB:
			{
				if(com.mod == 0)	// AB off
					ext_fscommand2("SetVidABOff", com.enb);
				else
				if(com.mod == 1)	// Set A
					ext_fscommand2("SetVidATime", com.ms);
				else
				if(com.mod == 2)	// Set B
					ext_fscommand2("SetVidBTime", com.ms);
				
			}			
			break;
			case this.PTIME:
			{
				if(com.mod == 0)	// cur time
					com.sec = ext_fscommand2("GetVidPlayTime");
				else
				if(com.mod == 1)	// total time
					com.sec = ext_fscommand2("GetVidTotalTime");
				
			}			
			break;
			//--------------------------------------------------
			//	default
			//--------------------------------------------------
			default:
				break;
		}	
		
		return result;
	}	
	//trace(this + "-");
	
	return trg.cmd;
}
//---------------------------------------------------------
// DestroyCommand
//---------------------------------------------------------
_root.DestroyCommand
= function(trg:Object):Boolean
{
	
	delete trg.cmd.pkt;
	delete trg.cmd;
	return true;
}
