
this.Get2ChiperNum = function(curVal:Number) : String
{
	if(curVal < 10)
	{
		return ("0" + String(curVal));
	}
	else
	{
		return String(curVal);
	}
}
this.GetTime2Text = function(time:Number):String
{
	var hour,min,sec;
	var leftTime;
	var tempTxt:String;
	hour = min = sec = 0;
//	time = 100;
	hour	= Math.floor(time/3600);
	min		= Math.floor(time%3600/60);
	sec		= Math.floor(time%3600%60);
	hour	= 	Get2ChiperNum(hour);
	min		=	Get2ChiperNum(min);
	sec		=	Get2ChiperNum(sec);

	tempTxt= hour + ":"+ min + ":" + sec;
	return tempTxt;
}
this.SetTime2MC 
= function(mcObj:Object, time:Number):Void
{
	var hour,min,sec;
	var trgFrameNum;
	hour = min = sec = 0;
	
	hour		= Math.floor(time/3600);
	min		= Math.floor(time%3600/60);
	sec		= Math.floor(time%3600%60);
	
	trgFrameNum = (sec%10)+1;
	if(mcObj.mcTime0._currentframe != trgFrameNum)
		mcObj.mcTime0.gotoAndStop(trgFrameNum);
		
	trgFrameNum = (sec/10)+1;
	if(mcObj.mcTime1._currentframe != trgFrameNum)
		mcObj.mcTime1.gotoAndStop(trgFrameNum);
	
	trgFrameNum = (min%10)+1;
	if(mcObj.mcTime2._currentframe != trgFrameNum)
		mcObj.mcTime2.gotoAndStop(trgFrameNum);
		
	trgFrameNum = (min/10)+1;
	if(mcObj.mcTime3._currentframe != trgFrameNum)
		mcObj.mcTime3.gotoAndStop(trgFrameNum);		
		
	trgFrameNum = (hour%10)+1;
	if(mcObj.mcTime4._currentframe != trgFrameNum)
		mcObj.mcTime4.gotoAndStop(trgFrameNum);
	
	trgFrameNum = (hour/10)+1;
	if(mcObj.mcTime5._currentframe != trgFrameNum)
		mcObj.mcTime5.gotoAndStop(trgFrameNum);

}
this.ToggleVisibleState=function(TargetMC:MovieClip)
{
	if(TargetMC._visible == true)
	{
		TargetMC._visible = false;
	}
	else
	{
		TargetMC._visible = true;
	}
	
}
var DoFlip:Number =0;
MovieflipFooter = function(SideA:MovieClip, SideB:MovieClip, flipMode:Number, fastMode:Number):Void{
	var fFlip:Number = 1;
	var parentMC:MovieClip = SideA._parent;
	var chMenu:Number = 0;
	if(DoFlip == 0)
	{
		
		
		{
			var bgHeight:Number=parentMC._width;
			var bgHalfHeight:Number = Math.ceil(parentMC._width*0.8);
			
			EventEnable(false, 0);
			
			DoFlip = 1 ;
			parentMC.onEnterFrame = function()
			{
				
				if(parentMC._width < 1)
				{
					fFlip = 2;
				}
		
				if(fFlip == 1)
				{
					if( parentMC._width > bgHalfHeight ) 
					{
						parentMC._width -=bgHalfHeight;	
					}
					else 
						parentMC._width=0;
				}
				
				
				if( fFlip==2) {
					
					if(bgHeight< bgHalfHeight + parentMC._width)
					{
						parentMC._width = bgHeight;
						DoFlip = 0 ;
						EventEnable(true, 0);
						delete parentMC.onEnterFrame;
					}
					else
						parentMC._width += bgHalfHeight;				
		
					if( parentMC._width > (bgHalfHeight-2) && chMenu == 0 )
					{
						ToggleVisibleState(SideA);
						ToggleVisibleState(SideB);
						chMenu =1;
					}
				} // if(fFlip ==2)
	
			}//onEnterFrame
		}
	}
	
}
this.Common_GetRatio = function(Total:Number, Current:Number)
{
	if(Total == 0 || Current == 0)
		return 0;
	else
		return Math.floor(Current* 100 / Total);
}
//-----------------------------------------------------------------------------
// System information
//-----------------------------------------------------------------------------
var prevVolume:Number=-1;
var currVolume:Number=-1;
var prevBatt :Number=-1;
var currBatt:Number=-1;
var prevMin:Number=-1;
var prevHold:Number=-1;
var currHold:Number=-1;
var prevBluetooth:Number=-1;
var currBluetooth:Number;
var display24Hour:Number;

this.systemInfo = function(Update:Number):Void
{
	this.DispTime(Update);
	this.DispVolume(Update);
	this.DispBatt(Update);
	this.DispHold(Update);
	this.DispBluetooth(Update);
}


this.DispVolume = function(Update:Number):Void
{	
	currVolume = ext_fscommand2("GetEtcVolume");
	if(Update == 1 || prevVolume != currVolume)
	{
		prevVolume=currVolume;
		_level1.MCCon.MCInfobar.TXVol.text =  currVolume;
	}

}


this.DispTime = function(Update:Number):Void
{
 // ÿ ο ð Եȴ. 
	var CurTime:Date = new Date();
	this.g_curHour 	= CurTime.getHours();
	this.g_curMin 	= CurTime.getMinutes();
	this.g_curSec 	= CurTime.getSeconds();

	if((Update == 1) || (this.g_curMin != prevMin))
	{
		prevMin = this.g_curMin;
		if(Update == 1)
		{
			display24Hour = ext_fscommand2("GetTim24HDisplay");
		}

		if(display24Hour)
		{
			_level1.MCCon.MCInfobar.TXTime.text = Get2ChiperNum(this.g_curHour ) + ":"
									  	+ Get2ChiperNum(this.g_curMin);
		}
		else
		{
			var tempHour:Number;

			if(this.g_curHour < 12)
			{
				tempHour = this.g_curHour;
				_level1.MCCon.MCInfobar.TXAmPm.text = "AM"
			}
			else
			{
				if(this.g_curHour != 12)
					tempHour = this.g_curHour- 12;
				else
					tempHour = this.g_curHour;
				_level1.MCCon.MCInfobar.TXAmPm.text = "PM"
			}

			_level1.MCCon.MCInfobar.TXTime.text = Get2ChiperNum(tempHour) + ":"
										  	+ Get2ChiperNum(this.g_curMin);
		}

		if(Update == 1)
		{
			if(display24Hour)
				_level1.MCCon.MCInfobar.TXAmPm._visible  = false;
			else
				_level1.MCCon.MCInfobar.TXAmPm._visible  = true;
		}
	}

	delete CurTime;
}

this.DispBatt = function(Update:Number):Void
{
  currBatt = ext_fscommand2("GetSysBattery");
	if(Update == 1 || currBatt != prevBatt)
	{
		prevBatt = currBatt;
		_level1.MCCon.MCInfobar.MCBatt.gotoAndStop(1+currBatt);					
	}

}
this.DispHold= function(Update:Number):Void{
	
	currHold = ext_fscommand2("GetSysHoldKey");
	if(Update==1 || currHold != prevHold)
	{
		prevHold = currHold;
		
		_level1.MCCon.MCInfobar.MCHold.gotoAndStop(ext_fscommand2("GetSysCtrlHoldState")+1)
		if(currHold == 1) 	
			_level1.MCCon.MCInfobar.MCHold._visible  = true;
		else					
			_level1.MCCon.MCInfobar.MCHold._visible  = false;	
	}
	
}

this.DispBluetooth = function(Update:Number):Void
{
	currBluetooth = ext_fscommand2("GetBTHState");
	
	if(prevBluetooth != currBluetooth || Update == 1)
	{
		prevBluetooth = currBluetooth;
		if(prevBluetooth == 1)
			_level1.MCCon.MCInfobar.MCBluetooth._visible = true;
		else
			_level1.MCCon.MCInfobar.MCBluetooth._visible = false;
	}
	
}



